// and_event.cc
// 04/26/17 ZC   initial version

#include <stdio.h>
#include "systemc.h"


class Main_Block : public sc_module
{
    public:
	sc_event e1,e2;
	sc_event_and_list e;
	int a1,a2,a3;
	void S1()
	{
		for(int i=0;i<10;i++){
			e1.notify(SC_ZERO_TIME);
			wait(1,SC_NS);
			a1++;
		}
	}
	void S2()
	{
		for(int i=0;i<10;i++){
			e2.notify(SC_ZERO_TIME);
			wait(1,SC_NS);
			a2++;
		}
	}
	void R()
	{	int i=0;
		printf("i=%d\n",i);
		for(;i<10;i++){
			wait(e);
			a3++;
		}

	}
	void before_end_of_elaboration(){

		e&=e1;
		e&=e2;

	}
	Main_Block(sc_module_name name)
	: sc_module(name)
	{
		a1=0;
		a2=0;
		a3=0;
		SC_THREAD(S1);
		SC_THREAD(S2);
		SC_THREAD(R);
	}
	SC_HAS_PROCESS(Main_Block);
};


int sc_main(int argc, char* argv[])
{
    Main_Block m("m");

    sc_start();
	assert(m.a1==10);
	assert(m.a2==10);
	assert(m.a3==10);
    printf("and_event1 done\n");
    return 0;
}

/* ex: set softtabstop=8 tabstop=8 shiftwidth=8 expandtab: */
